package myextra;

import java.io.File;
import java.io.IOException;
import java.io.Serializable;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.Set;
import java.util.Map.Entry;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.model.SelectItem;
import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;

import myextra.myfrwext.MyTestManager;
import org.apache.commons.httpclient.Credentials;
import org.apache.commons.httpclient.Header;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpException;
import org.apache.commons.httpclient.HttpMethod;
import org.apache.commons.httpclient.auth.AuthScope;
import org.apache.commons.httpclient.methods.GetMethod;
import org.apache.log4j.Logger;
import org.apache.log4j.PropertyConfigurator;
import org.apache.myfaces.trinidad.component.UIXCollection;
import org.apache.myfaces.trinidad.component.UIXTable;
import org.apache.myfaces.trinidad.component.UIXTree;
import org.apache.myfaces.trinidad.model.RowKeySet;
import org.gbif.connect.Concept;
import org.gbif.connect.ConceptSet;
import org.gbif.connect.RequestFactory;
import org.gbif.connect.biocase.ABCD12RequestFactory;
import org.gbif.connect.biocase.ABCD148RequestFactory;
import org.gbif.connect.biocase.ABCD206RequestFactory;
import org.gbif.connect.digir.DwC12RequestFactory;
import org.gbif.connect.digir.DwC20RequestFactory;
import org.gbif.connect.digir.MaNISRequestFactory;
import org.gbif.connect.digir.OBISRequestFactory;
import org.gbif.datatester.DataTest;
import org.gbif.datatester.KnownConcepts;
import org.gbif.datatester.Tag;
import org.gbif.datatester.exception.TestInitializationException;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.Namespace;
import org.jdom.input.SAXBuilder;
import org.xml.sax.InputSource;

/**
 * @author loancea
 */
public class Controller implements Serializable {
	/**
	 * generated srialVersionUID
	 */
	private static final long serialVersionUID = 1L;
	private static final int[] ALL_CONCEPTS = { Concept.ID_CATALOGNUMBER,
			Concept.ID_SCIENTIFICNAME, Concept.ID_SUBSPECIES,
			Concept.ID_SPECIES, Concept.ID_GENUS, Concept.ID_FAMILY,
			Concept.ID_AUTHOR, Concept.ID_COUNTRY, Concept.ID_LATITUDE,
			Concept.ID_LONGITUDE, Concept.ID_INSTITUTIONCODE,
			Concept.ID_COLLECTIONCODE, Concept.ID_COLLECTIONDATE,
			Concept.ID_COLLECTIONDAY, Concept.ID_COLLECTIONMONTH,
			Concept.ID_COLLECTIONYEAR, Concept.ID_RECORDBASIS,
	// ABCDConcept.ID_METADATA_CODE //Title
	};
	private Logger logger;
	// private FileUpload _upFile;
	private String _name = "";
	private String uploadstatus = "No file loaded";
	private String serviceURL = null;
	private boolean _isDescoveried = false;
	private boolean _isDiscoveryDetailed = false;
	private String discoverystatus = "not discovered";
	private String discoverydetails = "Provider " + discoverystatus;
	private String standard = "";
	private String resource = "";
	private String selectedprotocol = "";
	private List<SelectItem> protocols = new ArrayList<SelectItem>();
	private List<SelectItem> resources = new ArrayList<SelectItem>();
	private boolean _isDigir = false;
	private int pageSize = 0;
	private String pageSizeS = "";
	private List<SelectItem> pageSizeValues = new ArrayList<SelectItem>();
	private List<SelectItem> filterconceptlist = new ArrayList<SelectItem>();
	private String concept = "Scientific name";
	private List<SelectItem> filteroperatorlist = new ArrayList<SelectItem>();
	private String operator = "is like";
	private String conceptValue = "%";
	private List<SelectItem> levelsList = new ArrayList<SelectItem>();
	private String levelName = "Info";
	private int timeout = 100000; // config paramenter
	private List<SelectItem> tests = new ArrayList<SelectItem>();
	private int testrowstable = 0;
	private List<DResult> testList = new ArrayList<DResult>();
	private String[] selectedtests = new String[0];
	private String testIdDetails = "";

	private String emailaddress = "";
	private String emailserver = "";
	private String emailsender = "";
	private String adminEmail = "";
	private String discoveryServerUrl;
	private Attributes attr = new Attributes();
	private String validation_code = "";
	private boolean codevalidated = false;
	private String generated_text = "";
	private String filename = "";
	private String fileURL = "";
	private List<String> selectedtestids = new ArrayList<String>();

	private UIComponent _Testtable = null;
	private KnownConcepts knownConcepts;
	private MyTestManager manager;

	// error list for showErrors()
	// the generics should work on the jvm > 1.5 sun ??
	// public List errorList = new ArrayList();
	public List<String> errorList = new ArrayList<String>();

	/**
	 * Retrive only one page with records
	 */
	private boolean onepage = true;

	/**
	 * @return the onepage
	 */
	public boolean isOnepage() {
		return onepage;
	}

	/**
	 * @param onepage
	 *            the onepage to set
	 */
	public void setOnepage(boolean onepage) {
		this.onepage = onepage;
	}

	public Controller() {
		pageSizeValues.add(new SelectItem(100, "100"));
		pageSizeValues.add(new SelectItem(200, "200"));
		pageSizeValues.add(new SelectItem(300, "300"));
		pageSizeValues.add(new SelectItem(400, "400"));
		pageSizeValues.add(new SelectItem(500, "500"));
		pageSizeValues.add(new SelectItem(1000, "1000"));
		pageSizeValues.add(new SelectItem(1500, "1500"));
		pageSizeValues.add(new SelectItem(2000, "2000"));
		pageSizeValues.add(new SelectItem(2500, "2500"));
		pageSizeValues.add(new SelectItem(3000, "3000"));
		pageSizeValues.add(new SelectItem(3500, "3500"));
		pageSizeValues.add(new SelectItem(4000, "4000"));
		pageSizeValues.add(new SelectItem(4500, "4500"));
		pageSizeValues.add(new SelectItem(5000, "5000"));

		standard = new String("Not detected");
		protocols.add(new SelectItem("Not detected"));

		// to do : i18n
		filterconceptlist.add(new SelectItem("Scientific name",
				"Scientific name"));
		filterconceptlist.add(new SelectItem("Country", "Country"));

		filteroperatorlist.add(new SelectItem("is like", "is like"));
		filteroperatorlist.add(new SelectItem("equals", "equals"));

		levelsList.add(new SelectItem("Info", "Info"));
		levelsList.add(new SelectItem("Warn", "Warn"));
		levelsList.add(new SelectItem("Error", "Error"));
		// levelsList.add(new SelectItem("All", "All"));
		int bytes = 0;
		Random rand = new Random(System.currentTimeMillis());
		bytes = rand.nextInt(6000);
		this.generated_text = new Integer(bytes).toString();

		// get list of all tests
		try {
			FacesContext facesContext = FacesContext.getCurrentInstance();
			HttpServletRequest req = (HttpServletRequest) facesContext
					.getExternalContext().getRequest();
			this.filename = "test_results-" + req.getSession().getId() + ".csv";

			String conceptsfilename = facesContext.getExternalContext()
					.getInitParameter("concepts_filename");
			this.fileURL = req.getRequestURL().toString();
			fileURL = fileURL.replaceAll("/datatester/faces/index.jspx", "");
			fileURL = fileURL.replaceAll("8080", "80");

			this.discoveryServerUrl = facesContext.getExternalContext()
					.getInitParameter("discovery_server_URL");
			this.emailserver = facesContext.getExternalContext()
					.getInitParameter("email_server");
			this.emailsender = facesContext.getExternalContext()
					.getInitParameter("email_sender");
			this.discoveryServerUrl = facesContext.getExternalContext()
					.getInitParameter("discovery_server_URL");
			this.pageSize = (new Integer(facesContext.getExternalContext()
					.getInitParameter("pageSize"))).intValue();
			this.adminEmail = facesContext.getExternalContext()
					.getInitParameter("admin_email");

			ServletContext servletContext = (ServletContext) facesContext
					.getExternalContext().getContext();
			String deploypath = servletContext.getRealPath("");

			String logconfigfilename = facesContext.getExternalContext()
					.getInitParameter("log_config_file");
			PropertyConfigurator.configureAndWatch(deploypath + "/WEB-INF/"
					+ logconfigfilename);
			logger = Logger.getLogger(this.getClass());

			logger.info("tomcat path:" + deploypath);

			String testsfilename = facesContext.getExternalContext()
					.getInitParameter("tests_filename");

			String availabetestsfilename = facesContext.getExternalContext()
					.getInitParameter("availabetests_filename");

			File conceptsConf = new File(deploypath + "/WEB-INF/"
					+ conceptsfilename);
			File testsConf = new File(deploypath + "/WEB-INF/" + testsfilename);
			File availabletests = new File(deploypath + "/WEB-INF/"
					+ availabetestsfilename);
			attr.knownConcepts = new KnownConcepts(conceptsConf);
			knownConcepts = new KnownConcepts(conceptsConf);
			// attr.manager = new TestManager(testsConf, attr.knownConcepts);

			attr.manager = new MyTestManager(testsConf, attr.knownConcepts,
					availabletests);
			manager = new MyTestManager(testsConf, attr.knownConcepts,
					availabletests);
			// show all available tests
			/*
			 * Map<String, String> alltest = (Map<String, String>)
			 * attr.manager .getAllTests();
			 * 
			 * for (Iterator<Map.Entry<String, String>> alltesti = alltest
			 * .entrySet().iterator(); alltesti.hasNext();) { Map.Entry<String,
			 * String> me = (Map.Entry<String, String>) alltesti .next();
			 * String testdesc = (String) me.getValue();
			 * 
			 * this.tests.add(new SelectItem((String) me.getKey(), testdesc));
			 * attr.selectedTests.add((String) me.getKey()); }
			 */
			Iterator<DataTest> testi = (Iterator<DataTest>) manager
					.getAllTestsDataTests().entrySet().iterator();
			DResult testrow = null;

			while (testi.hasNext()) {
				Entry<String, DataTest> me = (Entry<String, DataTest>) testi
						.next();
				DataTest test = me.getValue();

				try {
					testrow = new DResult(me.getKey(), test.getDescription(),
							test.minNumberOfRecords(), test.getInstanceXml(),
							test.getMandatoryConcepts());

					String testdesc = testrow.getTestdesc();
					String testid = me.getKey();

					if (testdesc.indexOf(":") > 0) {
						testdesc = testdesc.substring(0, testdesc.indexOf(":"));
					}
					;
					if (testdesc.indexOf("\"") > 0
							& testid.equalsIgnoreCase("01")) {
						testdesc = testdesc
								.substring(0, testdesc.indexOf("\""));
						testdesc = "Checks if the Scientific name matches a predefiend pattern (see details)";
					}
					;

					if (testdesc.startsWith("Checks that")) {
						testdesc = testdesc.replace("Checks that", "Checks if");
					}
					;

					Set<org.gbif.datatester.Concept> mandconcepts = testrow
							.getMandatoryConcepts();
					Iterator<org.gbif.datatester.Concept> iterator = mandconcepts
							.iterator();
					String conceptname = null;
					while (iterator.hasNext()) {
						// pentru fiecare concept naeme sa fiefacut
						// <strong><i><i/><strong/>
						conceptname = iterator.next().getName();
						if (testdesc.indexOf("\"" + conceptname + "\"") > 0) {
							testdesc = testdesc
									.replaceFirst("\"" + conceptname + "\"",
											"<b><i>" + conceptname + "<i/></b>");
						} else if (testdesc.indexOf("\"" + conceptname) > 0) {
							testdesc = testdesc.replaceFirst(
									"\"" + conceptname, "<b><i>" + conceptname
											+ "<i/></b>");
						} else if (testdesc.indexOf(conceptname + "\"") > 0) {
							testdesc = testdesc.replaceFirst(
									conceptname + "\"", "<b><i>" + conceptname
											+ "<i/></b>");
						} else {
							testdesc = testdesc.replaceFirst(conceptname,
									"<b><i>" + conceptname + "<i/></b>");
						}
						// testdesc = testdesc.replaceFirst(conceptname,
						// "<b><i>"+conceptname+"<i/></b>") ;
					}
					testrow.setShortdesc(testdesc);

					testList.add(testrow);
				} catch (TestInitializationException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}

				logger.info("get the classes");

				/*
				 * test.getOptionalConcepts(); // test.getPossibleTags();
				 */
			}
		} catch (Exception exc) {
			exc.printStackTrace();
		}
	}

	public void cleadriscovery() {
		discoverystatus = "Not discovered";
		discoverydetails = "\n";
		_isDescoveried = false;
		_isDiscoveryDetailed = false;
		protocols.clear();
		resources.clear();
		serviceURL = "";
	}

	public void discover() {
		protocols.clear();
		resources.clear();
		resource = null;
		attr.resource = null;
		discoverystatus = "Provider not discovered";
		discoverydetails = "\n";

		String url_new = this.discoveryServerUrl.replaceFirst("__serviceURL__",
				this.serviceURL);

		if (this.serviceURL != null) {
			Credentials creds = null;
			HttpClient client = new HttpClient();
			// establish a connection within 5 seconds
			client.getHttpConnectionManager().getParams().setConnectionTimeout(
					this.timeout);

			// set the default credentials
			if (creds != null) {
				client.getState().setCredentials(AuthScope.ANY, creds);
			}

			// String url = args[0];
			HttpMethod method = null;
			// create a method object
			method = new GetMethod(url_new);
			method.setFollowRedirects(true);

			// } catch (MalformedURLException murle) {
			// System.out.println("<url> argument '" + url
			// + "' is not a valid URL");
			// System.exit(-2);
			// }

			// execute the method
			String responseBody = null;

			try {
				client.executeMethod(method);
				responseBody = method.getResponseBodyAsString();

				// write out the request headers
				discoverydetails = discoverydetails + "*** Request *** " + "\n";
				discoverydetails = discoverydetails + "Request Path: "
						+ method.getPath() + "\n";
				discoverydetails = discoverydetails + "Request Query: "
						+ method.getQueryString() + "\n";
				discoverydetails = discoverydetails + "Request Headers: \n";
				_isDiscoveryDetailed = true;

				Header[] requestHeaders = method.getRequestHeaders();

				for (int i = 0; i < requestHeaders.length; i++) {
					discoverydetails = discoverydetails + requestHeaders[i]
							+ "\n";
				}

				// write out the response headers
				discoverydetails = discoverydetails + "*** Response ***\n";
				discoverydetails = discoverydetails + "Status Line: "
						+ method.getStatusLine() + "\n";
				discoverydetails = discoverydetails + "Response Headers: \n";

				Header[] responseHeaders = method.getResponseHeaders();

				for (int i = 0; i < responseHeaders.length; i++) {
					discoverydetails = discoverydetails + responseHeaders[i]
							+ "\n";
				}

				// write out the response body
				discoverydetails = discoverydetails + "*** Response Body ***\n";
				discoverydetails = discoverydetails + responseBody + "\n";

				// clean up the connection resources
				method.releaseConnection();

				InputSource inputsource = new InputSource(new StringReader(
						responseBody));
				// SAXParser detectionresponseparser = new SAXParser();
				// ProviderDetectionResponseParser hander = new
				// ProviderDetectionResponseParser(this.logger);
				// detectionresponseparser.setContentHandler(handler);
				// detectionresponseparser.setErrorHandler(handler)
				// detectionresponseparser.parse(inputsource);

				SAXBuilder builder = new SAXBuilder();
				Document document = builder.build(inputsource);
				Element root = document.getRootElement();
				logger.info("XML Elements: ");

				Namespace namespace = root.getNamespace();
				Element op = root.getChild("info", namespace);
				Element srv_type = op.getChild("server_type", namespace);
				this.standard = srv_type.getTextTrim();

				if (this.standard.equalsIgnoreCase("biocase")) {
					for (Iterator<Element> prot_it = op.getChildren(
							"SupportedSchemas", namespace).iterator(); prot_it
							.hasNext();) {
						this.protocols.add(new SelectItem(prot_it.next()
								.getText()));
					}

					this._isDigir = false;
					this.selectedprotocol = ((Element) op.getChildren(
							"SupportedSchemas", namespace).get(0)).getText();
				}

				if (this.standard.equalsIgnoreCase("digir")) {
					for (Iterator<Element> prot_it = op.getChildren(
							"conceptualSchema", namespace).iterator(); prot_it
							.hasNext();) {
						this.protocols.add(new SelectItem(prot_it.next()
								.getText()));
					}

					this.selectedprotocol = ((Element) op.getChildren(
							"conceptualSchema", namespace).get(0)).getText();

					

					this._isDigir = true;
					if(this.isDigir()) {
						for (Iterator<Element> res_it = op.getChildren(
								"resource", namespace).iterator(); res_it
								.hasNext();) {
							this.resources.add(new SelectItem(res_it.next()
									.getText()));
						}
						this.resource = ((Element) op.getChildren(
								"resource", namespace).get(0)).getText();
					}else {
						for (Iterator<Element> res_it = op.getChildren(
								"server_resource", namespace).iterator(); res_it
								.hasNext();) {
							this.resources.add(new SelectItem(res_it.next()
									.getText()));
						}
						this.resource = ((Element) op.getChildren(
								"server_resource", namespace).get(0)).getText();	
					}
					
				}

				;
				this.discoverystatus = "discovered";
				this._isDescoveried = true;

				logger.info("*** Response Body ***");
			} catch (HttpException he) {
				logger.error("Http error connecting to '" + url_new + "'");
				logger.error(he.getMessage());
				this._isDescoveried = false;
				this._isDiscoveryDetailed = true;
				this.discoverydetails = "Connection Problem.Http error connecting to '"
						+ url_new + "'\n" + discoverydetails;
				this.discoverystatus = "not Discovered";
			} catch (IOException ioe) {
				logger.error("Unable to connect to '" + url_new + "'");
				this._isDescoveried = false;
				this._isDiscoveryDetailed = true;
				this.discoverydetails = "Connection Problem. Unable to connect to '"
						+ url_new + "'\n" + discoverydetails;
				this.discoverystatus = "not Discovered";
			} catch (JDOMException e) {
				logger.error(e.getMessage());
				this._isDescoveried = false;
				this._isDiscoveryDetailed = true;
				this.discoverydetails = "Parsing discovery response problem \n"
						+ discoverydetails;
				this.discoverystatus = "not Discovered";
			}
		}

		// this._isDescoveried = true;
	}

	/**
	 * @return the _isDescoveried
	 */
	public boolean isDescoveried() {
		return _isDescoveried;
	}

	/**
	 * @return the standard
	 */
	public String getStandard() {
		return standard;
	}

	/**
	 * @param standard
	 *            the standard to set
	 */
	public void setStandard(String standard) {
		this.standard = standard;
	}

	/**
	 * @return the serviceURL
	 */
	public String getServiceURL() {
		return serviceURL;
	}

	/**
	 * @param serviceURL
	 *            the serviceURL to set
	 */
	public void setServiceURL(String serviceURL) {
		this.serviceURL = serviceURL.trim();
	}

	/**
	 * @return the schemas
	 */
	public List<SelectItem> getProtocols() {
		return protocols;
	}

	/**
	 * @return the resources
	 */
	public List<SelectItem> getResources() {
		return resources;
	}

	/**
	 * @return the _isDigir
	 */
	public boolean isDigir() {
		return _isDigir;
	}

	/**
	 * @return the testList
	 */
	public List<SelectItem> getTests() {
		return tests;
	}

	/**
	 * @return the selectedTests
	 */
	public String[] getSelectedtests() {
		return selectedtests;
	}

	/**
	 * @param selectedTests
	 *            the selectedTests to set
	 */
	public void setSelectedtests(String[] selectedtests) {
		this.selectedtests = selectedtests;
	}

	/**
	 * @param testsList
	 *            the testsList to set
	 */
	public void setTests(List<SelectItem> tests) {
		this.tests = tests;
	}

	/**
	 * @return the slectedprotocol
	 */
	public String getSelectedprotocol() {
		return selectedprotocol;
	}

	/**
	 * @param slectedprotocol
	 *            the slectedprotocol to set
	 */
	public void setSelectedprotocol(String selectedprotocol) {
		this.selectedprotocol = selectedprotocol;
	}

	// public FileUpload getUpFile() {
	// return _upFile;
	// }

	// public void setUpFile(FileUpload upFile) {
	// _upFile = upFile;
	// }

	public String getName() {
		return _name;
	}

	public void setName(String name) {
		_name = name;
	}

	public String upload() throws IOException {
		/*
		 * this.uploadstatus = "File loading ..."; FacesContext facesContext =
		 * FacesContext.getCurrentInstance();
		 * facesContext.getExternalContext().getApplicationMap().put(
		 * "fileupload_bytes", _upFile.getBytes());
		 * facesContext.getExternalContext().getApplicationMap().put(
		 * "fileupload_type", _upFile.getContentType());
		 * facesContext.getExternalContext().getApplicationMap().put(
		 * "fileupload_name", _upFile.getName()); this._name =
		 * _upFile.getName(); this.uploadstatus = "Validating .. "; try {
		 * Validator vd = new Validator(logger); InputSource inp_source = new
		 * InputSource(this._upFile .getInputStream()); XMLReader xrp = new
		 * org.apache.xerces.parsers.SAXParser();
		 * xrp.setFeature("http://apache.org/xml/features/validation/schema",
		 * true);
		 * xrp.setFeature("http://xml.org/sax/features/namespace-prefixes",
		 * true); // set the content and error handler. XmlExtractor xe = new
		 * XmlExtractor(logger, "biocase"); xrp.setContentHandler(xe);
		 * xrp.setErrorHandler(xe); xrp.parse(inp_source); String docStr =
		 * xe.getDocStr(); vd.validate(docStr);
		 * attr.errorList.add(vd.getMessage()); this.uploadstatus =
		 * vd.getMessage(); } catch (SAXNotRecognizedException e) {
		 * e.printStackTrace(); } catch (SAXNotSupportedException e) {
		 * e.printStackTrace(); } catch (SAXException e) { e.printStackTrace(); }
		 */
		return null;
	}

	public boolean isUploaded() {
		FacesContext facesContext = FacesContext.getCurrentInstance();
		Object val = facesContext.getExternalContext().getApplicationMap().get(
				"fileupload_bytes");
		boolean rez = false;

		if (val != null) {
			rez = true;
		} else {
			rez = false;
		}

		return rez;
	}

	/**
	 * @return the _filesize
	 */
	// public Long getFilesize() {
	// if (_upFile != null) {
	// // return _upFile.getSize();
	// return new Long(1);
	// } else {
	// return new Long(0);
	// }
	// }
	private boolean getParameters() {
		// get service URL
		this.attr.getErrorList().clear();
		errorList.clear();
		if ((serviceURL == null) || serviceURL.trim().equals("")) {
			attr.errorList.add("No service URL");
			errorList.add("No service URL");
		} else {
			if ((serviceURL.startsWith("http") == true)
					|| (serviceURL.length() > 0)) {
				attr.serviceURL = serviceURL.trim();
				serviceURL = serviceURL.trim();
			} else {
				attr.errorList.add("Malformated service URL");
				errorList.add("Malformated service URL");
				logger.info("Malformted URL " + serviceURL);
			}
		}

		// get resource
		// if (_upFile == null) {
		// if (resource != null) {
		// attr.resource = resource.trim();
		// resource = resource.trim();
		// if (resource.length() == 0) {
		// attr.resource = null;
		// resource = null;
		// }
		// }

		// select request factory
		if ((selectedprotocol == null)) {
			attr.errorList.add("No protocol");
			errorList.add("No protocol");
		} else if (selectedprotocol.equals("dwc12")
				|| selectedprotocol
						.equals("http://digir.net/schema/conceptual/darwin/2003/1.0")) {
			attr.reqFactory = DwC12RequestFactory.getInstance();
			attr.isDarwinCore = true;
		} else if (selectedprotocol.equals("dwc20")
				|| selectedprotocol
						.equals("http://digir.net/schema/conceptual/darwin/2003/1.0")) {
			attr.reqFactory = DwC20RequestFactory.getInstance();
			attr.isDarwinCore = true;
		} else if (selectedprotocol.equals("obis")) {
			attr.reqFactory = OBISRequestFactory.getInstance();
			attr.isDarwinCore = true;
		} else if (selectedprotocol.equals("manis")) {
			attr.reqFactory = MaNISRequestFactory.getInstance();
			attr.isDarwinCore = true;
		} else if (selectedprotocol.equals("abcd12")
				|| selectedprotocol
						.equals("http://www.tdwg.org/schemas/abcd/1.2")) {
			attr.reqFactory = ABCD12RequestFactory.getInstance();
			attr.isDarwinCore = false;
		} else if (selectedprotocol.equals("abcd148")) {
			attr.reqFactory = ABCD148RequestFactory.getInstance();
			attr.isDarwinCore = false;
		} else if (selectedprotocol.equals("abcd206")
				|| selectedprotocol
						.equals("http://www.tdwg.org/schemas/abcd/2.06")) {
			attr.reqFactory = ABCD206RequestFactory.getInstance();
			attr.isDarwinCore = false;
		} else {
			attr.errorList.add("Unknown protocol: " + selectedprotocol);
		}

		// select concept
		if (concept == null) {
			attr.errorList.add("No concept");
		} else if (concept.equals("sciName")
				|| concept.equals("Scientific name")) {
			attr.conceptId = Concept.ID_SCIENTIFICNAME;
		} else if (concept.equals("species")) {
			attr.conceptId = Concept.ID_SPECIES;
		} else if (concept.equals("genus")) {
			attr.conceptId = Concept.ID_GENUS;
		} else if (concept.equals("family")) {
			attr.conceptId = Concept.ID_FAMILY;
		} else if (concept.equals("country") || concept.equals("Country")) {
			attr.conceptId = Concept.ID_COUNTRY;
		} else {
			attr.errorList.add("Unknown filter concept: " + concept);
		}

		// select operator
		if (operator == null) {
			attr.errorList.add("No operator");
		} else if (operator.equals("equals")) {
			attr.operator = RequestFactory.OPERATOR_EQUALS;
		} else if (operator.equals("like") || operator.equals("is like")) {
			attr.operator = RequestFactory.OPERATOR_LIKE;
		} else {
			attr.errorList.add("Unknown operator: " + operator);
		}

		// get concept val
		if ((conceptValue == null) || conceptValue.trim().equals("")) {
			attr.errorList.add("No concept value");
		} else {
			attr.conceptValue = conceptValue.trim();
		}

		// select tag level
		if (levelName == null) {
			attr.errorList.add("No tag level");
		} else if (levelName.equals("Debug")) {
			attr.level = Tag.Level.DEBUG;
		} else if (levelName.equals("Info")) {
			attr.level = Tag.Level.INFO;
		} else if (levelName.equals("Warn")) {
			attr.level = Tag.Level.WARN;
		} else if (levelName.equals("Error")) {
			attr.level = Tag.Level.ERROR;
		} else if (levelName.equals("fatal")) {
			attr.level = Tag.Level.FATAL;
		} else {
			attr.errorList.add("Unknown tag level: " + levelName);
		}
		// }

		/*
		 * if (selectedtests.length == 0) { attr.errorList .add("No selected
		 * tests. Please select at least one test to run."); }
		 */
		return attr.errorList.isEmpty();
	}

	public String testrun() {
		logger.info("do the tests");

		if (!this.validation_code.equalsIgnoreCase(this.generated_text)) {
			attr.errorList
					.add("Validation code not correct. No email will be sent.");
			this.attr.setValidated(false);
		} else {
			attr.setValidated(true);
		}

		UIXCollection table = (UIXCollection) _Testtable;
		final RowKeySet state;

		if (table instanceof UIXTable) {
			state = ((UIXTable) table).getSelectedRowKeys();
		} else {
			state = ((UIXTree) table).getSelectedRowKeys();
		}

		Iterator<Object> selection = state.iterator();
		Object oldKey = table.getRowKey();
		List<Object> _selection = new ArrayList<Object>();

		while (selection.hasNext()) {
			table.setRowKey(selection.next());
			_selection.add(table.getRowData());
			selectedtestids.add(((DResult) table.getRowData()).getTestid());
		}

		table.setRowKey(oldKey);

		// if (_upFile != null) {
		// attr.requestData = null;
		// attr.responseData = null;
		//
		// // an provider URL http
		// FileTestExecutor fileTestexecutor = new FileTestExecutor(logger,
		// attr, this);
		// fileTestexecutor.run();
		// }

		if (getParameters()) {
			logger.info("Parameters Alless ok !! ");

			try {
				// /////////////////////////
				// create concept list
				ConceptSet conceptSet = attr.reqFactory.getConceptSet();
				attr.factoryConcepts = new HashMap<Object, Object>();

				ArrayList<String> list = new ArrayList<String>();
				attr.requestData = null;
				attr.responseData = null;

				for (int i = 0; i < ALL_CONCEPTS.length; i++) {
					ArrayList<Concept> concepts = (ArrayList<Concept>) conceptSet
							.getConceptsById(ALL_CONCEPTS[i]);

					if ((concepts != null) && !concepts.isEmpty()) {
						Concept c = concepts.get(0);

						attr.factoryConcepts.put(new Integer(c.getId()), c);
						list.add(c.getName());
					}
				}

				if (standard.equalsIgnoreCase("biocase")) {
					Concept c = (Concept) attr.reqFactory.getConceptSet()
							.getConceptByPath("Unit/Gathering")
							.getSubconcepts().getConceptByPath(
									"./Country/ISO3166Code");
					attr.factoryConcepts.put(new Integer(200), c);

					c = (Concept) attr.reqFactory.getConceptSet()
							.getConceptByPath(
									"Unit/Identifications/Identification")
							.getSubconcepts().getConceptByPath(
									"./Result/TaxonIdentified");
					attr.factoryConcepts.put(new Integer(201), c);
				}

				/**
				 * if (attr.knownConcepts == null) { attr.knownConcepts = new
				 * KnownConcepts(conceptsConf); attr.manager = new
				 * TestManager(testsConf, attr.knownConcepts); }
				 * 
				 * attr.manager = new TestManager(testsConf,
				 * attr.knownConcepts);
				 */
				if (this.attr.getPagingthread() != null) {
					this.attr.getPagingthread().join();
				}

				this.attr.setPagingthread(new PagingRetriever(attr, pageSize,
						logger, list, this, this.emailaddress, this.filename,
						this.fileURL));

				this.attr.getPagingthread().start();
			} catch (Exception exc) {
				logger.info(exc.getMessage());
				exc.printStackTrace();
			}
		}

		return "weiter";
	}

	public void stoptests() {
		if (this.attr.getPagingthread() != null) {
			try {
				// if(this.attr.getPagingthread().isInterrupted())
				// {
				// this.attr.getPagingthread().
				// }
				this.attr.getPagingthread().interrupt();
				this.attr.getPagingthread().join();
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}

	/**
	 * @return the resource
	 */
	public String getResource() {
		return resource;
	}

	/**
	 * @param resource
	 *            the resource to set
	 */
	public void setResource(String resource) {
		this.resource = resource;
	}

	/**
	 * @return the pageSize
	 */
	public int getPageSize() {
		return pageSize;
	}

	/**
	 * @param pageSize
	 *            the pageSize to set
	 */
	public void setPageSize(int pageSize) {
		this.pageSize = pageSize;
	}

	/**
	 * @return the concept
	 */
	public String getConcept() {
		return concept;
	}

	/**
	 * @param concept
	 *            the concept to set
	 */
	public void setConcept(String concept) {
		this.concept = concept;
	}

	/**
	 * @return the operator
	 */
	public String getOperator() {
		return operator;
	}

	/**
	 * @param operator
	 *            the operator to set
	 */
	public void setOperator(String operator) {
		this.operator = operator;
	}

	/**
	 * @return the conceptValue
	 */
	public String getConceptValue() {
		return conceptValue;
	}

	/**
	 * @param conceptValue
	 *            the conceptValue to set
	 */
	public void setConceptValue(String conceptValue) {
		this.conceptValue = conceptValue;
	}

	/**
	 * @return the levelName
	 */
	public String getLevelName() {
		return levelName;
	}

	/**
	 * @param levelName
	 *            the levelName to set
	 */
	public void setLevelName(String levelName) {
		this.levelName = levelName;
	}

	/**
	 * @return the errorList
	 */
	public List<String> getErrorList() {
		return attr.errorList;
	}

	/**
	 * @param errorList
	 *            the errorList to set
	 */
	public void setErrorList(List<String> errorList) {
		this.attr.errorList = errorList;
	}

	/**
	 * @return the pageSizeValues
	 */
	public List<SelectItem> getPageSizeValues() {
		return pageSizeValues;
	}

	/**
	 * @param pageSizeValues
	 *            the pageSizeValues to set
	 */
	public void setPageSizeValues(List<SelectItem> pageSizeValues) {
		this.pageSizeValues = pageSizeValues;
	}

	/**
	 * @return the pageSizeS
	 */
	public String getPageSizeS() {
		return pageSizeS;
	}

	/**
	 * @param pageSizeS
	 *            the pageSizeS to set
	 */
	public void setPageSizeS(String pageSizeS) {
		this.pageSizeS = pageSizeS;
	}

	/**
	 * @return the uploadstatus
	 */
	public String getUploadstatus() {
		return uploadstatus;
	}

	/**
	 * @param uploadstatus
	 *            the uploadstatus to set
	 */
	public void setUploadstatus(String uploadstatus) {
		this.uploadstatus = uploadstatus;
	}

	/**
	 * @return the emailaddress
	 */
	public String getEmailaddress() {
		return emailaddress;
	}

	/**
	 * @param emailaddress
	 *            the emailaddress to set
	 */
	public void setEmailaddress(String emailaddress) {
		this.emailaddress = emailaddress;
	}

	/**
	 * @return the attr
	 */
	public Attributes getAttr() {
		return attr;
	}

	public void setAttr(Attributes attr) {
		this.attr = attr;
	}

	/**
	 * @return the validation_code
	 */
	public String getValidation_code() {
		return validation_code;
	}

	/**
	 * @param validation_code
	 *            the validation_code to set
	 */
	public void setValidation_code(String validation_code) {
		this.validation_code = validation_code;
	}

	/**
	 * @return the generated_text
	 */
	public String getGenerated_text() {
		return generated_text;
	}

	/**
	 * @param generated_text
	 *            the generated_text to set
	 */
	public void setGenerated_text(String generated_text) {
		this.generated_text = generated_text;
	}

	/**
	 * @return the discoverystatus
	 */
	public String getDiscoverystatus() {
		return discoverystatus;
	}

	/**
	 * @param discoverystatus
	 *            the discoverystatus to set
	 */
	public void setDiscoverystatus(String discoverystatus) {
		this.discoverystatus = discoverystatus;
	}

	/**
	 * @return the discoverydetails
	 */
	public String getDiscoverydetails() {
		return discoverydetails;
	}

	/**
	 * @param discoverydetails
	 *            the discoverydetails to set
	 */
	public void setDiscoverydetails(String discoverydetails) {
		this.discoverydetails = discoverydetails;
	}

	/**
	 * @return the emailserver
	 */
	public String getEmailserver() {
		return emailserver;
	}

	/**
	 * @param emailserver
	 *            the emailserver to set
	 */
	public void setEmailserver(String emailserver) {
		this.emailserver = emailserver;
	}

	/**
	 * @return the emailsender
	 */
	public String getEmailsender() {
		return emailsender;
	}

	/**
	 * @param emailsender
	 *            the emailsender to set
	 */
	public void setEmailsender(String emailsender) {
		this.emailsender = emailsender;
	}

	/**
	 * @return the _isDescoveryDetailed
	 */
	public boolean isDiscoveryDetailed() {
		return _isDiscoveryDetailed;
	}

	public void preparetestiddetails() {
		FacesContext context = FacesContext.getCurrentInstance();
		Map map = context.getExternalContext().getRequestParameterMap();
		this.setTestIdDetails((String) map.get("detailtestid"));
		logger.info((String) map.get("detailtestid"));
	}

	public String getAdminEmail() {
		return adminEmail;
	}

	public void setAdminEmail(String adminEmail) {
		this.adminEmail = adminEmail;
	}

	public List<SelectItem> getFilterconceptlist() {
		return filterconceptlist;
	}

	public void setFilterconceptlist(List<SelectItem> filterconceptlist) {
		this.filterconceptlist = filterconceptlist;
	}

	public List<SelectItem> getFilteroperatorlist() {
		return filteroperatorlist;
	}

	public void setFilteroperatorlist(List<SelectItem> filteroperatorlist) {
		this.filteroperatorlist = filteroperatorlist;
	}

	public List<SelectItem> getLevelsList() {
		return levelsList;
	}

	public void setLevelsList(List<SelectItem> levelsList) {
		this.levelsList = levelsList;
	}

	public List<DResult> getTestList() {
		return testList;
	}

	public void setTestList(List<DResult> testList) {
		this.testList = testList;
	}

	public DResult getTestDetails(String _testid) {
		DResult res = null;
		boolean found = false;
		int index = 0;

		while (!found && (index < testList.size()) && (_testid != null)) {
			DResult currres = testList.get(index);

			if (currres.getTestid().equals(_testid)) {
				res = currres;
				found = true;
			}

			index++;
		}

		return res;
	}

	public DResult getTestDetails() {
		DResult res = null;
		boolean found = false;
		int index = 0;

		while (!found && (index < testList.size()) && (testIdDetails != null)) {
			DResult currres = testList.get(index);

			if (currres.getTestid().equals(testIdDetails)) {
				res = currres;
				found = true;
			}

			index++;
		}

		return res;
	}

	public UIComponent getTestTable() {
		// ((UIXTable)_Testtable).
		return _Testtable;
	}

	public void setTestTable(UIComponent hgrid) {
		_Testtable = hgrid;
	}

	public int getTestrowstable() {
		return testrowstable;
	}

	public void setTestrowstable(int testrowstable) {
		this.testrowstable = testrowstable;
	}

	public String getTestIdDetails() {
		return testIdDetails;
	}

	public void setTestIdDetails(String testIdDetails) {
		this.testIdDetails = testIdDetails;
	}

	public List<String> getSelectedtestids() {
		return selectedtestids;
	}

	public void setSelectedtestids(List<String> selectedtestids) {
		this.selectedtestids = selectedtestids;
	}

	public int getSelectedtestscounter() {
		int rez = 0;
		if (((UIXTable) _Testtable).getSelectedRowKeys() != null) {
			rez = ((UIXTable) _Testtable).getSelectedRowKeys().getSize();

		} else {
			rez = 0;
		}
		return rez;
	}

	/**
	 * @return the codevalidated
	 */
	public boolean isCodevalidated() {
		if (this.validation_code.equalsIgnoreCase(this.generated_text)) {
			this.codevalidated = true;
		}
		;

		return codevalidated;
	}

	 public void clearAllData() {
	        attr.conceptId = 0;
	        attr.conceptValue = null;

	        if (!this.errorList.isEmpty()) {
	            this.errorList.clear();
	        }

	        if (attr.factoryConcepts != null) {
	            if (!attr.factoryConcepts.isEmpty()) {
	            	attr.factoryConcepts.clear();
	            }
	        }

	        if (attr.idDefinition != null) {
	            if (!attr.idDefinition.isEmpty()) {
	            	attr.idDefinition.clear();
	            }
	        }

	        attr.isDarwinCore = false;
	        attr.isFileURL = false;
	        // this.knownConcepts= null;
	        attr.level = null;
	        attr.manager = null;
	        attr.operator = 0;

	        if (attr.records != null) {
	            if (!attr.records.isEmpty()) {
	            	attr.records.clear();
	            }
	        }

	        attr.recordSet = null;
	        attr.reqFactory = null;
	        attr.requestData = null;
	        attr.resource = null;
	        attr.responseData = null;

	        if (attr.selectedTests != null) {
	            if (!attr.selectedTests.isEmpty()) {
	            	attr.selectedTests.clear();
	            }
	        }

	        attr.serviceURL = null;
	        attr.globalresultmanager = null;

	        if (testList != null) {
	            Iterator<DResult> resultsiterator = testList.iterator();

	            while (resultsiterator.hasNext()) {
	                DResult curr_res = resultsiterator.next();

	                if (curr_res.getRecordsresult() != null) {
	                    curr_res.getRecordsresult().clear();
	                }
	            }
	        }
	    }

	
	
	/**
	 * @param codevalidated
	 *            the codevalidated to set
	 */
	public void setCodevalidated(boolean codevalidated) {
		this.codevalidated = codevalidated;
	}
}
