package myextra;

import java.io.Serializable;
import java.util.List;
import java.util.Set;

import org.gbif.datatester.Concept;

/**
 * @author     loancea
 */
public class DResult implements Serializable {
    /**
     *
     */
    private static final long serialVersionUID = -5659131940499014486L;
    private String testid;
    private String testdesc;
    private String shortdesc;
    private int errors = 0;
    private int minNumOfRecords;
    private String testXml;
    private Set<Concept> mandatoryConcepts;
    private List<DRow> recordsresult;

    public DResult(String _id, String _desc) {
        this.testid = _id;
        this.testdesc = _desc;
    }

    public DResult(String id, String desc, int _minNumRecords, String _testXml,
        Set<Concept> _mandatoryConcepts) {
        this.testid = id;
        this.testdesc = desc;
        this.minNumOfRecords = _minNumRecords;
        this.testXml = _testXml;
        this.mandatoryConcepts = _mandatoryConcepts;
    }

    public DResult(String id, String desc, List<DRow> rows) {
        this.testid = id;
        this.testdesc = desc;
        this.recordsresult = rows;
    }

    /**
     * @return the testdesc
     */
    public String getTestdesc() {
        return testdesc;
    }

    /**
     * @param testdesc the testdesc to set
     */
    public void setTestdesc(String testdesc) {
        this.testdesc = testdesc;
    }

    /**
     * @return the testid
     */
    public String getTestid() {
        return testid;
    }

    /**
     * @param testid the testid to set
     */
    public void setTestid(String testid) {
        this.testid = testid;
    }

    /**
     * @return the errors
     */
    public int getErrors() {
        return errors;
    }

    /**
     * @param errors the errors to set
     */
    public void setErrors(int errors) {
        this.errors = errors;
    }

    public void addErrors(int add) {
        this.errors = this.errors + add;
    }

    /**
     * @return the recordsresult
     */
    public List<DRow> getRecordsresult() {
        return recordsresult;
    }

    /**
     * @param recordsresult the recordsresult to set
     */
    public void setRecordsresult(List<DRow> recordsresult) {
        this.recordsresult = recordsresult;
    }

    /**
     * @return the minNumOfRecords
     */
    public int getMinNumOfRecords() {
        return minNumOfRecords;
    }

    /**
     * @param minNumOfRecords the minNumOfRecords to set
     */
    public void setMinNumOfRecords(int minNumOfRecords) {
        this.minNumOfRecords = minNumOfRecords;
    }

    /**
     * @return the testXml
     */
    public String getTestXml() {
        return testXml;
    }

    /**
     * @param testXml the testXml to set
     */
    public void setTestXml(String testXml) {
        this.testXml = testXml;
    }

    /**
     * @return the mandatoryConcepts
     */
    public Set<org.gbif.datatester.Concept> getMandatoryConcepts() {
        return mandatoryConcepts;
    }

    /**
     * @param mandatoryConcepts the mandatoryConcepts to set
     */
    public void setMandatoryConcepts(Set<Concept> mandatoryConcepts) {
        this.mandatoryConcepts = mandatoryConcepts;
    }

    public String getShortdesc() {
        return shortdesc;
    }

    public void setShortdesc(String shortdesc) {
        this.shortdesc = shortdesc;
    }
}
