package myextra;

import javax.faces.context.FacesContext;
import myextra.Controller;
import org.apache.log4j.Logger;
import org.gbif.connect.Concept;
import org.gbif.connect.ConnectionException;
import org.gbif.connect.ConnectionPool;
import org.gbif.connect.Request;
import org.gbif.connect.RequestFactory;
import org.gbif.connect.Response;
import org.gbif.connect.SODetailRequest;


/**
 * @author     loancea
 */
public class DetailsRecord {
    private Logger logger = Logger.getRootLogger();
    private String UnitID;

    
    public String getDetailsrecord() {
        String rez = null;
        Controller controller = (Controller) FacesContext.getCurrentInstance()
                                                         .getApplication()
                                                         .getVariableResolver()
                                                         .resolveVariable(FacesContext.getCurrentInstance(),
                "controller");

        logger.info("got controller");

        //this.UnitID = tmpBean.getUnitID();
        int newoperator = RequestFactory.OPERATOR_EQUALS;
        int newconceptid = Concept.ID_CATALOGNUMBER;
        logger.info("got " + UnitID + " " + newconceptid + " " + newoperator);

        SODetailRequest detailrequest;

        try {
            detailrequest = controller.getAttr().reqFactory.createSODetailRequest(0,
                    controller.getAttr().serviceURL, Request.TIMEOUT_NONE,
                    Request.PRIORITY_NORMAL, controller.getAttr().resource,
                    newconceptid, UnitID, newoperator);

            ConnectionPool pool = ConnectionPool.getConnectionPool("demo");
            pool.submit(detailrequest);
            detailrequest.waitForResponse();

            Response detailresponse = detailrequest.getResponse();

            if (detailresponse == null) {
                controller.getAttr().errorList.add("No response from provider");
            }

            //controller.getAttr().responseData = detailresponse.getXmlResponseString();
            rez = detailresponse.getXmlResponseString();

            String error = detailresponse.getProcessingErrors(Response.SEVERITY_FATAL);

            if (error != null) {
                controller.getAttr().errorList.add("Error from provider: " +
                    error);
            }
        } catch (ConnectionException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }

        return rez;
    }

    /**
     * @return the unitID
     */
    public String getUnitID() {
        return UnitID;
    }

    /**
     * @param unitID the unitID to set
     */
    public void setUnitID(String unitID) {
        UnitID = unitID;
    }
}
