package myextra;

import com.sun.image.codec.jpeg.JPEGCodec;
import com.sun.image.codec.jpeg.JPEGImageEncoder;

import org.apache.myfaces.custom.dynamicResources.ResourceContext;
import org.apache.myfaces.custom.graphicimagedynamic.ImageContext;
import org.apache.myfaces.custom.graphicimagedynamic.ImageRenderer;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.image.BufferedImage;

import java.io.ByteArrayOutputStream;
import java.io.IOException;


import javax.faces.context.FacesContext;
import javax.faces.context.ResponseStream;


/**
 * @author loancea
 *
 */
public class GraphicImageDynamicTextBean implements ImageRenderer {
    private String _text;
    private byte[] bytes = null;

    public String getText() {
        return _text;
    }

    public void setText(String text) {
        this._text = text;
    }

    public void setContext(FacesContext facesContext,
        ResourceContext resourceContext) throws IOException {
        ImageContext imageContext = (ImageContext) resourceContext;
        Object text = imageContext.getParamters().get("text");

        if (text == null) {
            text = "";
        }

        int width = 300;
        int height = 30;
        Integer widthObj = imageContext.getWidth();

        if (widthObj != null) {
            width = widthObj.intValue();
        }

        Integer heightObj = imageContext.getHeight();

        if (heightObj != null) {
            height = heightObj.intValue();
        }

        BufferedImage img = new BufferedImage(width, height,
                BufferedImage.TYPE_INT_RGB);
        Graphics graphics = img.getGraphics();

        try {
            graphics.setColor(Color.WHITE);
            graphics.fillRect(0, 0, width, height);
            graphics.setColor(Color.BLUE);
           
            graphics.drawString(text.toString(), 10, 20);

            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            JPEGImageEncoder encoder = JPEGCodec.createJPEGEncoder(baout);
            encoder.encode(img);
            baout.flush();
            bytes = baout.toByteArray();
        } finally {
            graphics.dispose();
        }
    }

    public Class getImageRenderer() {
        return this.getClass();
    }

    /**
     * @see org.apache.myfaces.custom.graphicimagedynamic.ImageRenderer#getContentType()
     */
    public String getContentType() {
        return "image/jpeg";
    }

    /**
     * @see org.apache.myfaces.custom.graphicimagedynamic.ImageRenderer#getContentLength()
     */
    public int getContentLength() {
        return -1;
    }

    /**
     * @see org.apache.myfaces.custom.graphicimagedynamic.ImageRenderer#renderImage(javax.faces.context.FacesContext, org.apache.myfaces.custom.graphicimagedynamic.ImageContext, java.io.OutputStream)
     */
    public void renderResource(ResponseStream out) throws IOException {
        out.write(bytes);
    }
}
