/**
 *
 */
package myextra.myfrwext;

import org.gbif.datatester.KnownConcepts;
import org.gbif.datatester.TestManager;
import org.gbif.datatester.exception.TestConfigurationException;
import org.gbif.datatester.exception.TestInitializationException;
import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

/**
 * @author loancea
 * 
 */
public class MyTestManager extends TestManager {
		
	private List<String> availabletests = new ArrayList<String>();

	public MyTestManager(File tfile, KnownConcepts kc, File availabletest)
			throws TestConfigurationException, TestInitializationException {
		super(tfile, kc);

		// take the extra elements and atributes
		try {
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			DocumentBuilder db = dbf.newDocumentBuilder();

			Document doc;
			NodeList nodes;

			// available tests classes
			doc = db.parse(availabletest);
			nodes = doc.getElementsByTagName("test");
			for (int i = 0; i < nodes.getLength(); i += 1) {
				NamedNodeMap pMap = nodes.item(i).getAttributes();
				availabletests.add(pMap.getNamedItem("class").getNodeValue());
			}

			doc = db.parse(tfile);
			nodes = doc.getElementsByTagName("test");

			for (int i = 0; i < nodes.getLength(); i += 1) {
				// Possible parameters
				Map<String, String> parameters = new HashMap<String, String>();
				NodeList nParams = nodes.item(i).getChildNodes();
				for (int j = 0; j < nParams.getLength(); j += 1) {

					// Get only nodes called <parameter>
					if (nParams.item(j).getNodeName().equals("description")) {

						// Parameter "name"
						NamedNodeMap pMap = nParams.item(j).getAttributes();
						// node value description

						
						// child eamxaples
						// Node pName = pMap.getNamedItem("name");
						// String parameterName = pName.getNodeValue();

						// Parameter value
						NodeList nValues = nParams.item(j).getChildNodes();

						for (int m = 0; m < nValues.getLength(); m += 1) {

							// Get only nodes called <parameter>
							if (nValues.item(m).getNodeName().equals("value")) {

								NamedNodeMap vMap = nValues.item(m)
										.getAttributes();
								Node pValue = vMap.getNamedItem("v");
								String parameterValue = pValue.getNodeValue();

								// note: for now, assume there will only be one
								// value!!
								// parameters.put( parameterName, parameterValue
								// );
								break;
							}
						}
					}

				}
			}

		} catch (ParserConfigurationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SAXException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	/**
	 * Export the current test configuration 
	 */
	public void exportXmlTestConfig() {
		
	}
	
	public void importXmlTestConfig(String a) {
		
	}
}
