package myextra.test;

import org.apache.log4j.Logger;

import org.xml.sax.InputSource;
import org.xml.sax.helpers.DefaultHandler;

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is validator.java
 *
 * The Initial Developer of the Original Code is
 * Jinling Li, Freie Universit�t Berlin, ZE Botanischer Garten und Botanisches Museum
 * Berlin-Dahlem.
 *
 * Portions created by the Initial Developer are Copyright (C) 2005
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * ***** END LICENSE BLOCK ***** */
import java.io.StringReader;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;


/**
 * <p>Title: Validator</p>
 * <p>Description: Class for validate XML file</p>
 * <p>August, 2005</p>
 * <p>Company: Botanic Garden and Botanical Museum Berlin-Dahlem</p>
 * @author Jinling Li
 * @version 1.0
 */
public class Validator extends DefaultHandler {
    private StringBuffer sb;
    private Logger logger;

    public Validator(Logger logger) {
        sb = new StringBuffer();
        this.logger = logger;
    }

    public void validate(String docStr) {
        logger.info("Validating ... ");

        try {
            SAXParserFactory parserf = SAXParserFactory.newInstance();
            parserf.setNamespaceAware(true);
            parserf.setValidating(true);
            // enable validation in pipeline
            parserf.setFeature("http://xml.org/sax/features/validation", true);
            // set validator to schema validation
            parserf.setFeature("http://apache.org/xml/features/validation/schema",
                true);
            parserf.setFeature("http://apache.org/xml/features/validation/schema-full-checking",
                true);

            InputSource input = new InputSource(new StringReader(docStr));
            SAXParser parser = parserf.newSAXParser();
            parser.parse(input, this);
            logger.info(sb.toString());
        } // end try
        catch (Exception e) {
            logger.fatal(e.getMessage());
        }
    }

    public void setfatalErrorMessage(String m) {
        sb.append(m + "\r\n");
    }

    public void setValidationMessage(String me) {
        sb.append(me + "\r\n");
    }

    public String getMessage() {
        if (sb.toString().length() > 0) {
            return sb.toString();
        } else {
            return "The XML file is valid!";
        }
    }
}
