package myextra.xml;

import java.io.CharArrayWriter;

import org.apache.log4j.Logger;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.xml.sax.helpers.DefaultHandler;

public class ProviderDetectionResponseParser extends DefaultHandler {

	private Logger logger;
	private CharArrayWriter textBuffer;
	
	public ProviderDetectionResponseParser(Logger _logger) {
		this.logger = _logger;
		this.textBuffer = new CharArrayWriter();
	}

	
	public void startElement(String namespaceURI, String localname,
	        String qname, Attributes attributes) throws SAXException {
		if(localname.equals("server_type")) {
			logger.info("got the server type");
		}
		
	}
	
	public void characters(char[] buffer, int start, int length) {
        textBuffer.write(buffer, start, length);
    }
	
	
	 //
    // ErrorHandler methods
    //

    /** Warning. */
    public void warning(SAXParseException ex) throws SAXException {
        logger.warn("Warning", ex);
    } // warning(SAXParseException)

    /** Error. */
    public void error(SAXParseException ex) throws SAXException {
       logger.error("Error", ex);
    } // error(SAXParseException)

    /** Fatal error. */
    public void fatalError(SAXParseException ex) throws SAXException {
        logger.fatal("Fatal Error", ex);
        //throw ex;
    } // fatalError(SAXParseException)

}
