<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:fn="http://www.w3.org/2004/07/xpath-functions" xmlns:xdt="http://www.w3.org/2004/07/xpath-datatypes" xmlns:n1="http://www.tdwg.org/schemas/abcd/2.06" 
    xmlns:efg="http://www.synthesys.info/ABCDEFG/1.0"
    exclude-result-prefixes="xsl xs fn xdt n1 efg">
    <xsl:output version="1.0" encoding="UTF-8" indent="yes" omit-xml-declaration="yes" media-type="text/html"/>

    
    <!--
        StratigraphicAttributions
    -->
    
    <!--MineralRockIdentifiedType-->
    <xsl:template name="MineralRockIdentifiedType">
        <xsl:if test="efg:MineralRockGroup/efg:MineralRockGroupName">
            <span class="label">Name: </span>
            <xsl:value-of select="string(efg:MineralRockGroup/efg:MineralRockGroupName)"/>
            <br/> 
        </xsl:if>       
        <xsl:if test="efg:MineralRockGroup/efg:MineralRockclassification">
            <span class="label">Classification: </span>
            <xsl:value-of select="efg:MineralRockGroup/efg:MineralRockclassification"/>
            <br/> 
        </xsl:if>     
        <xsl:if test="efg:ClassifiedName">
            <xsl:if test="efg:ClassifiedName/efg:FullScientificNameString">
                <span class="label">Full Scientific Name: </span>
                <xsl:value-of select="efg:ClassifiedName/efg:FullScientificNameString"/>
                <br/>
            </xsl:if>
            <xsl:if test="efg:ClassifiedName/efg:NameAtomised">
                
                <xsl:if test="efg:ClassifiedName/efg:NameAtomised/efg:ScientificNameString">
                    <span class="label">Scientific Name: </span>
                    <xsl:value-of select="efg:ClassifiedName/efg:NameAtomised/efg:ScientificNameString"/>
                    <br/>
                </xsl:if>
                <xsl:if test="efg:ClassifiedName/efg:NameAtomised/efg:AuthorTeamAndYear">
                    <span class="label">Author (Team): </span>
                    <xsl:value-of select="efg:ClassifiedName/efg:NameAtomised/efg:AuthorTeamAndYear"/>
                    <br/>
                </xsl:if>
                <xsl:if test="efg:ClassifiedName/efg:NameAtomised/efg:MineralRockClassification">
                    <span class="label">Mineral Rock Classification: </span>
                    <xsl:value-of select="efg:ClassifiedName/efg:NameAtomised/efg:MineralRockClassification"/>
                    <br/>
                </xsl:if>
            </xsl:if>
            <xsl:if test="efg:InformalNameString">
                <span class="label">Informal Name: </span>
                <xsl:value-of select="efg:InformalNameString"/>
                <br/>
            </xsl:if>
            <xsl:if test="efg:VarietalNameString">
                <span class="label">Varietal Name: </span>
                <xsl:value-of select="efg:VarietalNameString"/>
                <br/>
            </xsl:if>
            <xsl:if test="efg:NameAddendum">
                <span class="label">Name_Addendum: </span>
                <xsl:value-of select="efg:NameAddendum"/>
                <br/>
            </xsl:if>
            <xsl:if test="efg:IdentificationQualifier">
                <span class="label">Identification Qualifier: </span>
                <xsl:value-of select="efg:IdentificationQualifier"/>
                <br/>
            </xsl:if>
            <xsl:if test="efg:Certainty">
                <span class="label">Certainty: </span>
                <xsl:value-of select="efg:Certainty"/>
                <br/>
            </xsl:if>
            <xsl:if test="efg:Identifiers">
                <span class="label">Identifiers: </span>
                <xsl:value-of select="efg:Identifiers"/>
                <br/>
            </xsl:if>
            <xsl:if test="efg:NameComments">
                <span class="label">Name_Comments: </span>
                <xsl:value-of select="efg:NameComments"/>
                <br/>
            </xsl:if>
        </xsl:if>
    </xsl:template>
    
    <!--StratigraphicAttributionsType -->
    <xsl:template name="StratigraphicAttributionsType">
        <!--
        <efg:ChronostratigraphicAttributions> efg:ChronostratigraphicAttributionsType </efg:ChronostratigraphicAttributions> [0..1] ?
        -->
            <xsl:if test="efg:ChronostratigraphicAttributions">
        	<p/>
        	<span class="label">Chronostratigraphic Attributions: </span>
        	<br></br>
        	<table width="96%" border="0">
        	<xsl:for-each select="efg:ChronostratigraphicAttributions/efg:ChronostratigraphicAttribution">
        		<!-- 
        		<span class="label">Unit Host Rock Stratigraphy:</span>
        		 -->
        		<tr>
        		<td>
	       			<span class="label">Division: </span>
					<xsl:value-of select="efg:ChronoStratigraphicDivision"/>
				</td>
				<td>
					<span class="label">Name: </span>
					<xsl:value-of select="efg:ChronostratigraphicName"/>
				</td>
				</tr>
				<xsl:if test="efg:DatingQualifier">
					<span class="label">Dating Qualifier: </span>
					<xsl:value-of select="efg:DatingQualifier"/>
					<br></br>									
				</xsl:if>
				<xsl:if test="efg:Certainty">
					<span class="label">Certainty: </span>
					<xsl:value-of select="efg:Certainty"/>
					<br></br>
				</xsl:if>
				<xsl:if test="efg:RangePosition">
					<span class="label">Range Position: </span>
					<xsl:value-of select="efg:RangePosition"/>
					<br></br>
				</xsl:if>
				<xsl:if test="efg:Identifiers">
					<span class="label">Identifiers: </span>
						<xsl:value-of select="efg:Identifiers"/>
					<br></br>
				</xsl:if>
				<xsl:if test="efg:StratigraphicMeasurementsOrFacts">
				
					<span class="label">Stratigraphic Measurements Or Facts: </span>
						<xsl:value-of select="efg:StratigraphicMeasurementsOrFacts"/>
					<br></br>
				</xsl:if>		
				
        	</xsl:for-each>
        	</table>
        </xsl:if>
        <!--       <efg:LithostratigraphicAttributions> efg:LithostratigraphicAttributionsType </efg:LithostratigraphicAttributions> [0..1] ?
        -->
        <xsl:if test="efg:LithostratigraphicAttributions">
        	<p/>
        	<span class="label">Lithostratigraphic Attributions: </span>
        	<br></br>
        	<table width="96%" border="0">
        	<xsl:for-each select="efg:LithostratigraphicAttributions/efg:LithostratigraphicAttribution">
        	<!-- 
        	<efg:Supergroup> xs:string </efg:Supergroup> [0..1] ?
				<efg:Group> xs:string </efg:Group> [0..1] ?
				<efg:Formation> xs:string </efg:Formation> [0..1] ?
				<efg:Member> xs:string </efg:Member> [0..1] ?
				<efg:Bed> xs:string </efg:Bed> [0..1] ?
				<efg:InformalLithostratigraphicName> xs:string </efg:InformalLithostratigraphicName> [0..1] ?
				<efg:Certainty> ... </efg:Certainty> [0..1]
				<efg:DatingQualifier> ... </efg:DatingQualifier> [0..1]
				<efg:Identifiers> efg:IdentifiersType </efg:Identifiers> [0..1]
				<efg:StratigraphicMeasurementsOrFacts> ... </efg:StratigraphicMeasurementsOrFacts> [0..1]
        	 -->
        	<xsl:if test="efg:Supergroup">
	        		<tr>
	        		<td>
		       			<span class="label">Supergroup: </span>
						<xsl:value-of select="efg:Supergroup"/>
					</td>
					</tr>
			</xsl:if >
			<xsl:if test="efg:Group">
					<tr>
	        		<td>
		       			<span class="label">Group: </span>
						<xsl:value-of select="efg:Group"/>
					</td>
					</tr>
			</xsl:if>
			<xsl:if test="efg:Formation">
					<tr>
	        		<td>
		       			<span class="label">Formation: </span>
						<xsl:value-of select="efg:Formation"/>
					</td>
					</tr>
			</xsl:if>
			<xsl:if test="efg:Member">
					<tr>
	        		<td>
		       			<span class="label">Member: </span>
						<xsl:value-of select="efg:Member"/>
					</td>
					</tr>
			</xsl:if>
			<xsl:if test="efg:Bed">
					<tr>
	        		<td>
		       			<span class="label">Bed: </span>
						<xsl:value-of select="efg:Bed"/>
					</td>
					</tr>
			</xsl:if>
			<xsl:if test="efg:InformalLithostratigraphicName">
					<tr>
	        		<td>
		       			<span class="label">Informal Lithostratigraphic Name: </span>
						<xsl:value-of select="efg:InformalLithostratigraphicName"/>
					</td>
					</tr>
			</xsl:if>
			<xsl:if test="efg:Certainty">
				<tr>
	        		<td>
		       			<span class="label">Certainty: </span>
						<xsl:value-of select="efg:Certainty"/>
					</td>
				</tr>
			</xsl:if>
			<xsl:if test="efg:DatingQualifier">
				<tr>
	        		<td>
		       			<span class="label">DatingQualifier: </span>
						<xsl:value-of select="efg:DatingQualifier"/>
					</td>
				</tr>
			</xsl:if>
			<xsl:if test="efg:Identifiers">
				<!-- 
				<xsl:calltemplate name="identifiertype"></xsl:calltemplate>
				 -->
				 <tr>
	        		<td>
		       			<span class="label">Identifier Name: </span>
						<xsl:value-of select="efg:Identifiers/efg:Person/PersonName"/>
					</td>
					<td>
		       			<span class="label">Identifier Organisation: </span>
						<xsl:value-of select="efg:Identifiers/efg:Organisation/Organisation"/>
					</td>
					
				</tr>
			</xsl:if>
			<xsl:if test="efg:StratigraphicMeasurementsOrFacts">
				<!-- 
				<xsl:calltemplate name=""></xsl:calltemplate>
				 -->
			</xsl:if>					
			</xsl:for-each>
			</table>
        	</xsl:if>       
        <!-- 
                <efg:BiostratigraphicAttributions> efg:BiostratigraphicAttributionsType </efg:BiostratigraphicAttributions> [0..1] ?
        -->
        <xsl:if test="efg:BiostratigraphicAttributions">
        	<br></br>
        	<table width="96%" border="0">
        	<xsl:for-each select="efg:BiostratigraphicAttributions/efg:BiostratigraphicAttribution">
        		<!--  <efg:ZonalFossilType> xs:string </efg:ZonalFossilType> [1] ?  -->
        		<tr>
	        		<td>
		       			<span class="label">ZonalFossilType: </span>
						<xsl:value-of select="efg:ZonalFossilType"/>
					</td>
				</tr>
				<!--  <efg:FossilZoneName> xs:string </efg:FossilZoneName> [1] ?  -->
        		<tr>
	        		<td>
		       			<span class="label">FossilZoneName: </span>
						<xsl:value-of select="efg:FossilZoneName"/>
					</td>
				</tr> 
				<!-- <efg:FossilSubzoneName> xs:string </efg:FossilSubzoneName> [0..1] ?  -->
				<xsl:if test="efg:FossilSubzoneName">
				<tr>
	        		<td>
		       			<span class="label">FossilSubzoneName: </span>
						<xsl:value-of select="efg:FossilSubzoneName"/>
					</td>
				</tr>
				</xsl:if>
				<!-- <efg:Certainty> ... </efg:Certainty> [0..1]  -->
				<xsl:if test="efg:Certainty">
				<tr>
	        		<td>
		       			<span class="label">Certainty: </span>
						<xsl:value-of select="efg:Certainty"/>
					</td>
				</tr>
				</xsl:if>
				<!-- <efg:RangePosition> xs:string </efg:RangePosition> [0..1] ?  -->
				<xsl:if test="efg:RangePosition">
				<tr>
	        		<td>
		       			<span class="label">RangePosition: </span>
						<xsl:value-of select="efg:RangePosition"/>
					</td>
				</tr>
				</xsl:if>
				<!-- <efg:DatingQualifier> ... </efg:DatingQualifier> [0..1]  -->
				<xsl:if test="efg:DatingQualifier">
				<tr>
	        		<td>
		       			<span class="label">DatingQualifier: </span>
						<xsl:value-of select="efg:DatingQualifier"/>
					</td>
				</tr>
				</xsl:if>
				<!-- <efg:Identifiers> efg:IdentifiersType </efg:Identifiers> [0..*]  -->
				<xsl:if test="efg:Identifiers">
				<!-- 
				<xsl:calltemplate name="identifiertype"></xsl:calltemplate>
				 -->
				 <tr>
	        		<td>
		       			<span class="label">Identifier Name: </span>
						<xsl:value-of select="efg:Identifiers/efg:Person/PersonName"/>
					</td>
					<td>
		       			<span class="label">Identifier Organisation: </span>
						<xsl:value-of select="efg:Identifiers/efg:Organisation/Organisation"/>
					</td>
					
				</tr>
				</xsl:if>
				<!-- <efg:StratigraphicMeasurementsOrFacts> ... </efg:StratigraphicMeasurementsOrFacts> [0..1] -->
				<xsl:if test="efg:StratigraphicMeasurementsOrFacts">
				<!-- 
				<xsl:calltemplate name=""></xsl:calltemplate>
				 -->
				</xsl:if>	
        	</xsl:for-each>
        	</table>
        </xsl:if>
        <!-- 
                <efg:MagnetostratigraphicDeterminations> efg:MagnetostratigraphicDeterminationsType </efg:MagnetostratigraphicDeterminations> [0..1] ?
         -->
         <xsl:if test="efg:MagnetostratigraphicDeterminations">
         	<p/>
        	<span class="label">Magnetostratigraphic Determinations: </span>
        	<br></br>
        	<table width="96%" border="0">
        	<xsl:for-each select="efg:MagnetostratigraphicDeterminations/efg:MagnetostratigraphicDetermination">
         	<!--  <efg:PolaritySuperchron> xs:string </efg:PolaritySuperchron> [0..1] ?  -->
         	<xsl:if test="efg:PolaritySuperchron">
         		<tr>
	        		<td>
		       			<span class="label">Polarity Superchron: </span>
						<xsl:value-of select="efg:PolaritySuperchron"/>
					</td>
				</tr>
         	</xsl:if>
			<!-- <efg:PolarityChron> xs:string </efg:PolarityChron> [0..1] ?  -->
			<xsl:if test="efg:PolarityChron">
         		<tr>
	        		<td>
		       			<span class="label">Polarity Chron: </span>
						<xsl:value-of select="efg:PolarityChron"/>
					</td>
				</tr>
         	</xsl:if>
			<!-- <efg:PolaritySubchron> xs:string </efg:PolaritySubchron> [0..1] ?  -->
			<xsl:if test="efg:PolaritySubchron">
         		<tr>
	        		<td>
		       			<span class="label">Polarity Subchron: </span>
						<xsl:value-of select="efg:PolaritySubchron"/>
					</td>
				</tr>
         	</xsl:if>
			<!--  <efg:MagnetostratigraphicDetail> xs:string </efg:MagnetostratigraphicDetail> [0..1] ?  -->
			<xsl:if test="efg:MagnetostratigraphicDetail">
         		<tr>
	        		<td>
		       			<span class="label">Magnetostratigraphic Detail: </span>
						<xsl:value-of select="efg:MagnetostratigraphicDetail"/>
					</td>
				</tr>
         	</xsl:if>
			<!-- <efg:AnalysisDateTime> ... </efg:AnalysisDateTime> [0..1]  -->
			<xsl:if test="efg:AnalysisDateTime">
         		<tr>
         			<xsl:if test="efg:AnalysisDateTime/efg:ExactDate">
	        		<td>
		       			<span class="label">Exact Analysis Date Time: </span>
						<xsl:value-of select="efg:AnalysisDateTime/efg:ExactDate"/>
					</td>
					</xsl:if>
					<xsl:if test="efg:AnalysisDateTime/efg:DateText">
	        		<td>
		       			<span class="label">Analysis Date Time: </span>
						<xsl:value-of select="efg:AnalysisDateTime/efg:DateText"/>
					</td>
					</xsl:if>
				</tr>
         	</xsl:if>
			<!-- <efg:Certainty> ... </efg:Certainty> [0..1]  -->
			<xsl:if test="efg:Certainty">
				<tr>
	        		<td>
		       			<span class="label">Certainty: </span>
						<xsl:value-of select="efg:Certainty"/>
					</td>
				</tr>
			</xsl:if>
			<!-- <efg:DatingQualifier> ... </efg:DatingQualifier> [0..1]  -->
			<xsl:if test="efg:DatingQualifier">
				<tr>
	        		<td>
		       			<span class="label">DatingQualifier: </span>
						<xsl:value-of select="efg:DatingQualifier"/>
					</td>
				</tr>
			</xsl:if>
			<!-- <efg:Identifiers> efg:IdentifiersType </efg:Identifiers> [0..1]  -->
			<xsl:if test="efg:Identifiers">
				<!-- 
				<xsl:calltemplate name="identifiertype"></xsl:calltemplate>
				 -->
				 <tr>
	        		<td>
		       			<span class="label">Identifier Name: </span>
						<xsl:value-of select="efg:Identifiers/efg:Person/PersonName"/>
					</td>
					<td>
		       			<span class="label">Identifier Organisation: </span>
						<xsl:value-of select="efg:Identifiers/efg:Organisation/Organisation"/>
					</td>
					
				</tr>
				</xsl:if>
			
			<!-- <efg:AnalysisReferences> ... </efg:AnalysisReferences> [0..*]  -->
			<xsl:if test="efg:AnalysisReferences">
			<xsl:for-each select="efg:AnalysisReferences/efg:AnalysisReference">
				<!-- 
					abcd refernce type
				 -->
			</xsl:for-each>
			</xsl:if>
			
         	</xsl:for-each>
         	</table>
         </xsl:if>
         <!-- 
                <efg:IsotopeStratigraphicDeterminations> efg:IsotopeStratigraphicDeterminationsType </efg:IsotopeStratigraphicDeterminations> [0..1] ?
          -->
          <xsl:if test="efg:IsotopeStratigraphicDeterminations">
	        <br></br>
        	<table width="96%" border="0">
           <xsl:for-each select="efg:IsotopeStratigraphicDeterminations/efg:IsotopeStratigraphicDetermination">
           	<tr>
           	<td>
           	<!-- <efg:IsotopesMeasured> xs:string </efg:IsotopesMeasured> [1] ? -->
	       	  	<span class="label">Isotopes Measured: </span>
				<xsl:value-of select="efg:IsotopesMeasured"/>   	
			</td>
			<td>
			<!-- <efg:IsotopeStratigraphicDetail> xs:string </efg:IsotopeStratigraphicDetail> [1] ?  -->
       		  	<span class="label">Isotope Stratigraphic Detail: </span>
				<xsl:value-of select="efg:IsotopeStratigraphicDetail"/>   	
			</td>
			</tr>
			
			<!-- <efg:AnalysisDateTime> ... </efg:AnalysisDateTime> [0..1]  -->
			<xsl:if test="efg:AnalysisDateTime">
         		<tr>
         			<xsl:if test="efg:AnalysisDateTime/efg:ExactDate">
	        		<td>
		       			<span class="label">Exact Analysis Date Time: </span>
						<xsl:value-of select="efg:AnalysisDateTime/efg:ExactDate"/>
					</td>
					</xsl:if>
					<xsl:if test="efg:AnalysisDateTime/efg:DateText">
	        		<td>
		       			<span class="label">Analysis Date Time: </span>
						<xsl:value-of select="efg:AnalysisDateTime/efg:DateText"/>
					</td>
					</xsl:if>
				</tr>
			</xsl:if>
				
			<!-- <efg:Certainty> ... </efg:Certainty> [0..1]  -->
			<xsl:if test="efg:Certainty">
				<tr>
	        		<td>
		       			<span class="label">Certainty: </span>
						<xsl:value-of select="efg:Certainty"/>
					</td>
				</tr>
			</xsl:if>

			<!-- <efg:DatingQualifier> ... </efg:DatingQualifier> [0..1]  -->
			<xsl:if test="efg:DatingQualifier">
				<tr>
	        		<td>
		       			<span class="label">DatingQualifier: </span>
						<xsl:value-of select="efg:DatingQualifier"/>
					</td>
				</tr>
			</xsl:if>
			
			<!-- <efg:Identifiers> efg:IdentifiersType </efg:Identifiers> [0..1]  -->
			<xsl:if test="efg:Identifiers">
				<!-- 
				<xsl:calltemplate name="identifiertype"></xsl:calltemplate>
				 -->
				 <tr>
	        		<td>
		       			<span class="label">Identifier Name: </span>
						<xsl:value-of select="efg:Identifiers/efg:Person/PersonName"/>
					</td>
					<td>
		       			<span class="label">Identifier Organisation: </span>
						<xsl:value-of select="efg:Identifiers/efg:Organisation/Organisation"/>
					</td>		
				</tr>
			</xsl:if>
			
			<!-- <efg:AnalysisReferences> ... </efg:AnalysisReferences> [0..1] -->  
			<xsl:if test="efg:AnalysisReferences">
			<xsl:for-each select="efg:AnalysisReferences/efg:AnalysisReference">
				<!-- 
					abcd refernce type
				 -->
			</xsl:for-each>
			</xsl:if>
			
           </xsl:for-each>
           </table>
          </xsl:if>
          <!-- 
                 <efg:RadiometricDates> efg:RadiometricDatesType </efg:RadiometricDates> [0..1] ?
           -->
           <xsl:if test="efg:RadiometricDates">
           	<br></br>
        	<table width="96%" border="0">
        	<xsl:for-each select="efg:RadiometricDates/efg:RadiometricDate">
        		<!--  <efg:RadiometricDatingMethod> xs:string </efg:RadiometricDatingMethod> [1] ?  -->
        		<tr>
        			<td>
        				<span class="label">Radiometric Dating Method: </span>
						<xsl:value-of select="efg:RadiometricDatingMethod"/>
        			</td>
        		</tr>

				<!--  <efg:MaterialDated> xs:string </efg:MaterialDated> [0..1] ? -->
				<xsl:if test="efg:MaterialDated">
				<tr>
        			<td>
        				<span class="label">Material Dated: </span>
						<xsl:value-of select="efg:MaterialDated"/>
        			</td>
        		</tr>
				</xsl:if>
				<!-- <efg:EarliestDate> xs:string </efg:EarliestDate> [1] ?  -->
				<tr>
        			<td>
        				<span class="label">Earliest Date: </span>
						<xsl:value-of select="efg:EarliestDate"/>
        			</td>
        		</tr>
        		<!-- <efg:LatestDate> xs:string </efg:LatestDate> [0..1] ?  -->
				<xsl:if test="efg:LatestDate">
				<tr>
        			<td>
        				<span class="label">Latest Date: </span>
						<xsl:value-of select="efg:LatestDate"/>
        			</td>
        		</tr>
				</xsl:if>
				<!-- <efg:TimeUnit> xs:string </efg:TimeUnit> [1] ?  -->
				<tr>
        			<td>
        				<span class="label">Time Unit: </span>
						<xsl:value-of select="efg:TimeUnit"/>
        			</td>
        		</tr>
				<!-- <efg:DatingAccuracy> xs:string </efg:DatingAccuracy> [0..1] ?  -->
				<xsl:if test="efg:DatingAccuracy">
				<tr>
        			<td>
        				<span class="label">Dating Accuracy: </span>
						<xsl:value-of select="efg:DatingAccuracy"/>
        			</td>
        		</tr>
				</xsl:if>
				<!-- <efg:DatingComment> xs:string </efg:DatingComment> [0..1] ?  -->
				<xsl:if test="efg:DatingComment">
				<tr>
        			<td>
        				<span class="label">Dating Comment: </span>
						<xsl:value-of select="efg:DatingComment"/>
        			</td>
        		</tr>
				</xsl:if>
				<!-- <efg:AnalysisDateTime> ... </efg:AnalysisDateTime> [0..1]  -->
				<xsl:if test="efg:AnalysisDateTime">
         		<tr>
         			<xsl:if test="efg:AnalysisDateTime/efg:ExactDate">
	        		<td>
		       			<span class="label">Exact Analysis Date Time: </span>
						<xsl:value-of select="efg:AnalysisDateTime/efg:ExactDate"/>
					</td>
					</xsl:if>
					<xsl:if test="efg:AnalysisDateTime/efg:DateText">
	        		<td>
		       			<span class="label">Analysis Date Time: </span>
						<xsl:value-of select="efg:AnalysisDateTime/efg:DateText"/>
					</td>
					</xsl:if>
				</tr>
				</xsl:if>
				<!-- <efg:Identifiers> efg:IdentifiersType </efg:Identifiers> [0..1]  -->
				<xsl:if test="efg:Identifiers">
				<!-- 
				<xsl:calltemplate name="identifiertype"></xsl:calltemplate>
				 -->
				 <tr>
	        		<td>
		       			<span class="label">Identifier Name: </span>
						<xsl:value-of select="efg:Identifiers/efg:Person/PersonName"/>
					</td>
					<td>
		       			<span class="label">Identifier Organisation: </span>
						<xsl:value-of select="efg:Identifiers/efg:Organisation/Organisation"/>
					</td>		
				</tr>
				</xsl:if>
				<!-- <efg:AnalysisReferences> ... </efg:AnalysisReferences> [0..1] -->
				<xsl:if test="efg:AnalysisReferences">
					<xsl:for-each select="efg:AnalysisReferences/efg:AnalysisReference">
						<!-- 
							abcd refernce type
						 -->
					</xsl:for-each>
				</xsl:if>
        	</xsl:for-each>	
            </table>
           </xsl:if>
           <!-- 
                <efg:PositionInSequence> xs:string </efg:PositionInSequence>
          --> 
          <xsl:if test="efg:PositionInSequence">
          	<span class="label">PositionInSequence: </span>
			<xsl:value-of select="efg:PositionInSequence"/>
          </xsl:if>
    </xsl:template>
    
    <xsl:template name="AnalysisAtomised">
        
    </xsl:template>
</xsl:stylesheet>